<template>
  <div>
    <div class="flex items-center justify-between mb-8">
      <t-span weight="bold">History</t-span>
      <a-custom-search></a-custom-search>
    </div>
    <a-table :columns="columns" :data-source="store.getPersonHistoryById(store.selectedPassengerId)" size="middle">
      <a slot="facePreview" slot-scope="id, row">
        <img :src="row.profilePhoto" />
      </a>
      <div slot="checkInTime" slot-scope="id, row">
        {{ getTime(row.checkInDate + 'T' + row.checkInTime) }}
      </div>
      <div slot="checkOutTime" slot-scope="id, row">
        {{ getTime(row.checkInDate + 'T' + row.checkOutTime) }}
      </div>
      <div slot="video" slot-scope="id, row" class="flex items-center justify-center">
        <person-video-dialog :passenger-id="row.globalId" :camera-id="row.cameraId" :start-time="toISO(row.checkInDate, row.checkInTime)" :end-time="toISO(row.checkInDate, row.checkOutTime)">
          <b-outline-action-button>
            <a-icon type="video-camera" class="text-2xl leading-none text-blue-default" />
          </b-outline-action-button>
        </person-video-dialog>
      </div>
    </a-table>
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import moment from 'moment'
import ACustomSearch from '~/components/shared/form/Search'
import TSpan from '~/components/shared/typography/Span'
import { useBuilding } from '~/store/building'
import PersonVideoDialog from '~/components/video/PersonVideoDialog.vue'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton.vue'

const columns = [
  {
    title: 'FACE PREVIEW',
    dataIndex: 'facePreview',
    key: 'facePreview',
    scopedSlots: { customRender: 'facePreview' },
    width: 120,
  },
  {
    title: 'FLOOR',
    dataIndex: 'floorName',
    key: 'floorName',
  },
  {
    title: 'AREA',
    dataIndex: 'areaName',
    key: 'areaName',
  },
  {
    title: 'UNIT',
    dataIndex: 'unitName',
    key: 'unitName',
  },
  {
    title: 'DATE',
    dataIndex: 'checkInDate',
    key: 'date',
  },
  {
    title: 'CHECK-IN',
    dataIndex: 'checkInTime',
    scopedSlots: { customRender: 'checkInTime' },
    key: 'checkIn',
  },
  {
    title: 'CHECK-OUT',
    dataIndex: 'checkOutTime',
    scopedSlots: { customRender: 'checkOutTime' },
    key: 'checkOut',
  },
  {
    title: 'VIDEO',
    dataIndex: '#',
    scopedSlots: { customRender: 'video' },
    key: 'video',
  },
]

export default defineComponent({
  components: { TSpan, ACustomSearch, PersonVideoDialog, BOutlineActionButton },
  setup() {
    const store = useBuilding()
    return { store }
  },
  data() {
    return {
      columns,
    }
  },
  methods: {
    getTime(isoDate) {
      return moment(isoDate).format('HH.mm.SS.SSS')
    },
    toISO(date, time) {
      return date + ' ' + time
    }
  },
})
</script>
